# 厫T̃eLXg̉
# ruby -Ks Kokugo.rb SKPKOKU2.DIC
# JgfBNgɎ̃t@Co͂
#   kokugo_nn (nn ̓ubNԍ) eubN̉̓eLXgt@C
#   kokugocontrols.txt  䕶O̕px

  scrPath = File::dirname($0.gsub(/\\/, '/'))
  $LOAD_PATH.unshift(scrPath)     # XNvgpX[hpXɒǉ

require 'SJParser'

B_KOKUGO     = 18  # ꎫT
B_NEO        = 19  # J^JiVꎫT
B_PERSON     = 20  # l
B_HYOGEN     = 21  # ތƕ\
B_USAGE      = 22  # g
B_THESAURUS  = 24  # V\[X
B_KATUYO     = 25  # p`
B_EXAMPLE    = 26  # p
B_KATUYONOTE = 27  # p`l

textBlocks = [B_KOKUGO, B_NEO, B_PERSON]
katuyoBlocks = [B_KATUYO]
simpleTextBlocks = [B_HYOGEN, B_USAGE, B_THESAURUS, B_EXAMPLE, B_KATUYONOTE]

def outfname(num)
  sprintf("kokugo_%02d", num)
end

def textOut(rec, n, refs, outf)
  outf.printf("---- %05d (%d) ", n, refs.size)
  refs.each do |adr|  # }
    x = sprintf("%02X:%02X%02X%02X", adr[0], adr[1], adr[2], adr[3])
    H[x.slice(0, 3)] += 1
    outf.print '{', x, '}'
  end
  outf.puts ''
  outf.puts rec
end

def katuyoOut(rec, n, refs, outf)
  outf.printf("---- %05d\n", n)
  outf.puts rec
  adr = refs
  if adr != nil
    x = sprintf("%02X:%02X%02X%02X", adr[0], adr[1], adr[2], adr[3])
    H['note:' + x.slice(0, 3)] += 1
    outf.print '{', x, '}', "\n"
  end
end

def noteOut(rec, n, refs, outf)
  outf.printf("---- %05d\n", n)
  outf.puts rec
end

def printBlock(infname, num, klass, func)
  outfname = outfname(num)
  STDERR.puts outfname
  outf = open(outfname, 'w')
  blk = klass::new(infname, num)
  n = 0

  blk.each do |rec, refs|
    STDERR.print n, "\r" if n % 10 == 0
    break if $DEBUG && n >= 10
    Object.send(func, rec, n, refs, outf)
    n += 1
  end

  STDERR.print n, "\n"
  blk.close
  outf.close
end

  infname = ARGV.shift.gsub(/\\/, '/')

  # {
  textBlocks.each do |num|
    printBlock(infname, num, TextBlock, :textOut)
  end

  # p`
  katuyoBlocks.each do |num|
    printBlock(infname, num, KatuyoBlock, :katuyoOut)
  end

  # ̑
  simpleTextBlocks.each do |num|
    printBlock(infname, num, SimpleTextBlock, :noteOut)
  end

  # 䕶AOȂǂo
  if H.size > 0
    open('kokugocontrols.txt', 'w') do |f|
      H.sort.each do |k, v|
        f.printf("%-10s %6d\n", k, v)
      end
    end
  end

__END__
