# X[p[{厫TpCu
#
# ڎsƁAȅWo͂ɏo͂
# (tpXŃXNvgw肷Kv邩Ȃ)
#   ruby -Ks SuperJ.rb *.DIC
# -d (fobO[h) w肷΁A\ƂƂ
# eubN <filename>_<nn> Ƃt@CŃJgɏo͂
#   ruby -Ks -d SuperJ.rb SKPKOGO2.DIC

########## 萔

ASIS_START      = 0x01
ASIS_END        = 0x02
START_OF_RECORD = 0x05

END_OF_LINE     = 0x1F
GAIZI           = 0x7F

FONT            = 0xFB
LABEL           = 0xFC
INDENT          = 0xFE
SPECIAL         = 0xFF
CONTROLS        = FONT..SPECIAL

ITALIC_START    = 0xFB11
ITALIC_END      = 0xFB12
BOLD_START      = 0xFB21
BOLD_END        = 0xFB22
UNDERLINE_START = 0xFB31
UNDERLINE_END   = 0xFB32
SUBSCRIPT_START = 0xFB51
SUBSCRIPT_END   = 0xFB52

LABEL_START     = 0xFC11
LABEL_END       = 0xFC12

TAB             = 0xFEA0

REF_START       = 0xFF01
REF_END         = 0xFF02
END_OF_BLOCK    = 0xFFFF

########## NX

class SuperJ < File

  attr_reader :pkgtitle, :dictitle, :copyright, :dicnum, :version, :key
  attr_reader :blocks

  alias getcRaw getc
  alias ungetcRaw ungetc
  alias readRaw read

  HEADER_SIZE = 0x100

  def getc
    c = getcRaw
    if c != nil
      c ^= @key
    end
    c
  end

  def ungetc(c)
    if c != nil
      ungetcRaw(c ^ @key)
    end
  end

  def read(len)
    s = readRaw(len)
    if s != nil
      s.length.times { |i|
        s[i] ^= @key
      }
    end
    s
  end

  def init

    # t@Cwb_
    rewind
    @pkgtitle = readRaw(32).strip
    @dictitle = readRaw(48).strip
    @copyright = readRaw(32).strip
    seek(0x79)
    @dicnum = readRaw(1)[0]
    seek(0x80)
    @version = gets("\x00").chomp("\x00")
    seek(0xA0)
    @key = readRaw(1)[0]

    # ubNTCYe[u
    filesize = File::size(self.path)
    seek(HEADER_SIZE)

    blksize = 0
    blks = []
    while true
      size, = read(4).unpack('V')
      blksize += size + 4
      blks.push(size)
      break if blksize + HEADER_SIZE >= filesize
    end
    if blksize + HEADER_SIZE != filesize
      raise 'size calculation error'
    end

    @blocks = []
    blkpos = HEADER_SIZE + 4 * blks.size
    blks.each do |size|
      @blocks.push({ 'pos' => blkpos, 'size' => size })
      blkpos += size
    end

  end

end

class BlockReader
  include Enumerable

  def initialize(fname, blockno)
    @f = SuperJ::open(fname, 'rb')
    @f.init
    @pos  = @f.blocks[blockno]['pos']
    @size = @f.blocks[blockno]['size']
    rewind
  end

  def close
    @f.close
  end

  def rewind
    @f.seek(@pos)
  end

  def getrec
    return nil # if @f.pos >= @pos + @size
  end

  def fetch(pos)
    @f.seek(pos)
    getrec
  end

  def each
    rewind
    while rec = getrec
      yield rec
    end
  end

end

# }`fBAf[^p

# 摜
class PicBlock < BlockReader

  def getrec
    return nil if @f.pos >= @pos + @size

    len = @f.getc
    count = @f.getc

    adrs = []
    count.times do
      adrs.push(@f.read(4))
    end
    title = @f.read(len)
    fname = @f.read(12)

    return { 'title' => title, 'fname' => fname, 'ref' => adrs }
  end

end

# 摜}bv
class PicMapBlock < BlockReader

  def getrec
    return nil if @f.pos >= @pos + @size

    len, = @f.read(2).unpack('n')
    count = @f.getc

    adrs = []
    count.times do
      adrs.push(@f.read(4))
    end
    title = @f.read(len)
    fname = @f.read(12)

    a = title.split('_')
    title = a.shift
    title, text = title.split('^')
    text = '' if text.nil?

    return { 'title' => title, 'fname' => fname, 'text' => text,
             'ref' => adrs, 'reftitle' => a }
  end

end

# F
class ColorBlock < BlockReader

  def getrec
    return nil if @f.pos >= @pos + @size

    len = @f.getc
    color = @f.read(7)
    title = @f.read(len)
    fname = @f.read(12)

    return { 'title' => title, 'fname' => fname, 'color' => color }
  end

end

# Sl
class HyakuninBlock < BlockReader

  def getrec
    return nil if @f.pos >= @pos + @size

    len = @f.getc
    title = @f.read(len)
    fnamePic = @f.read(12)
    fnameSound = @f.read(12)

    return { 'title' => title, 'fnamePic' => fnamePic, 'fnameSound' => fnameSound }
  end

end

# 
class KansiBlock < BlockReader

  def getrec
    return nil if @f.pos >= @pos + @size

    len = @f.getc
    title = @f.read(len)
    fnamePic = @f.read(12)
    fnameCSound = @f.read(12)
    fnameJSound = @f.read(12)

    return { 'title' => title, 'fnamePic' => fnamePic,
             'fnameCSound' => fnameCSound, 'fnameJSound' => fnameJSound }
  end

end

  def datapath(filename)
    if filename =~ /^(..).+\.(JPG|WAV|MPG)$/
      prefix = $1; ext = $2
      case ext
      when 'JPG' then path = 'data/Jpg'
      when 'WAV' then path = 'data/Snd'
      when 'MPG' then path = 'data/Mov'
      end
      "#{path}/#{prefix}/#{filename}"
    else
      filename
    end
  end

##########

if __FILE__ == $0

  spec = ARGV.shift.gsub(/\\/, '/')

  Dir[spec].each do |fname|
    # ̎Ƃ킴Tʌ`
    if File::basename(fname) =~ /^SKPJSPK/i
      open(fname, 'rb') do |f|
        copyright = f.read(30).strip
        version = f.read(10).strip
        title = f.read(38).strip
        key = f.read(1)

        print 'filename: ', fname, "\n"
        print 'title: ', title, "\n"
        print 'version: ', version, "\n"
        print 'copyright: ', copyright, "\n"
        print 'key: ', sprintf("%02X", key[0]), "h\n"
        print "\n"
      end
    else
      SuperJ.open(fname, 'rb') do |f|
        f.init

        print 'filename: ', fname, "\n"
        print 'package: ', f.pkgtitle, "\n"
        print 'dic: ', f.dictitle, "\n"
        print 'copyright: ', f.copyright, "\n"
        print 'dic num: ', f.dicnum, "\n"
        print 'version: ', f.version, "\n"
        print 'key: ', sprintf("%02X", f.key), "h\n"
        print "\n"

        filesize = File::size(fname)
        printf("filesize: %d (%X)\n", filesize, filesize)

        blocks = f.blocks
        print 'block count: ', blocks.size, "\n"
        print "block no.  position     size\n"
        blocks.each_with_index do |v, n|
          printf("block %02d: %8Xh %8d\n", n, v['pos'], v['size'])
        end

        print "\n"

if $DEBUG
        # ubNo
        basename = File::basename(fname, '.DIC')
        blocks.each_with_index do |v, n|
          outfname = sprintf("%s_%02d", basename, n)
          STDERR.print outfname, ':', v['size'], "\n"
          open(outfname, 'wb') do |outf|
            f.seek(v['pos'])
            outf.write(f.read(v['size']))
          end
        end
end

      end
    end
  end

end
